using System;
using System.Collections.Generic;
using System.Text;
using CodeSmith.Engine;
using SchemaExplorer;
using System.Data;
using System.ComponentModel;
using System.IO;
using System.Windows.Forms;
namespace YcCodeHelper
{
    public class BuildAllCode : CodeTemplate
    {
        #region 

        private TableSchemaCollection _tables;

        public TableSchemaCollection Tables
        {
            get { return _tables; }
            set { _tables = value; }
        }

        private string _projectName;

        [Category("01.Ŀ")]
        [Description("Ŀƣռ")]
        public string ProjectName
        {
            get { return _projectName; }
            set { _projectName = value; }
        }

        #region Output
        //óѡһļе·
        private string _outputDirectory = String.Empty;

        //[Editor(typeof(System.Windows.Forms.Design.FolderNameEditor), typeof(System.Drawing.Design.UITypeEditor))]
        //[CodeTemplateProperty(CodeTemplatePropertyOption.Optional)]
        [Category("0-Ŀ")]
        [Description("ĸĿ¼")]
        [DefaultValue("")]
        public string OutputDirectory
        {
            get
            {
                if (_outputDirectory.Length == 0)
                {
                    return @"C:\YcSoft";
                }
                else
                {
                    return _outputDirectory;
                }
            }
            set
            {
                if (value.EndsWith("\\")) value = value.Substring(0, value.Length - 1);
                _outputDirectory = value;
            }
        }

        #endregion
        #endregion

        #region Get Template
        public CodeTemplate GetCodeTemplate(string TemplateName)
        {
            //CodeTemplate template=null;
            CodeTemplateCompiler compiler = new CodeTemplateCompiler(this.CodeTemplateInfo.DirectoryName + TemplateName);

            compiler.CodeTemplateInfo.ToString();
            compiler.Compile();
            if (compiler.Errors.Count == 0)
            {
                return compiler.CreateInstance();
            }
            else
            {
                System.Text.StringBuilder errorMessage = new System.Text.StringBuilder();
                for (int i = 0; i < compiler.Errors.Count; i++)
                {
                    errorMessage.Append(compiler.Errors[i].ToString()).Append("\n");
                }
                throw new ApplicationException(errorMessage.ToString());
            }
        }
        #endregion

        #region Render File
        /// Copies all properties to a template
        /// Renders the file 
        /// NB. the overrite property
        public void RenderFileUsingProperties(string fullPath, bool overrite, ref CodeTemplate template)
        {
            if (overrite || (!File.Exists(fullPath)))
            {
                CopyPropertiesTo(template);
                template.RenderToFile(fullPath, overrite);
            }
        }

        /// Copies all properties to a template
        /// Renders the file 
        /// NB. the overrite property
        /// Set Property SourceTable
        public void RenderFileUsingProperties(string fullPath, bool overrite, ref CodeTemplate template, TableSchema SourceTable)
        {
            if (overrite || (!File.Exists(fullPath)))
            {
                CopyPropertiesTo(template);
                template.SetProperty("SourceTable", SourceTable);
                template.RenderToFile(fullPath, overrite);
            }
        }



        #endregion

        #region DAL.SqlClient
        #region Property
        private bool _dALSqlClient_GenerateAll = false;
        [Category("DAL.SqlClient")]
        [Description("ȫչ")]
        public bool GenerateAll_DALSqlClient
        {
            get
            {
                return _dALSqlClient_GenerateAll;
            }
            set
            {
                _dALSqlClient_GenerateAll = value;
            }
        }

        #endregion

        #region Method

        //ݱƷʵ
        public static string GetClassName(TableSchema table)
        {
            if (table == null)
            {
                return null;
            }
            return table.Name;
        }

        public bool GenerateDALSqlClientCode()
        {
            //ļĴļ趨ļĴļ
            string DALSqlClientDirectory = OutputDirectory + "\\" + ProjectName + "\\DAL.SqlClient\\";
            if (!Directory.Exists(DALSqlClientDirectory)) Directory.CreateDirectory(DALSqlClientDirectory);

            string PropertiesDirectory = OutputDirectory + "\\" + ProjectName + "\\DAL.SqlClient\\Properties\\";
            if (!Directory.Exists(PropertiesDirectory)) Directory.CreateDirectory(PropertiesDirectory);

            string ProvidersDirectory = OutputDirectory + "\\" + ProjectName + "\\DAL.SqlClient\\Providers\\";
            if (!Directory.Exists(ProvidersDirectory)) Directory.CreateDirectory(ProvidersDirectory);


            //ģ                
            CodeTemplate ModelProviderTemplate = GetCodeTemplate("\\DAL.SqlClient\\ModelProvider.cst");
            CodeTemplate ModelProviderGeneratedTemplate = GetCodeTemplate("\\DAL.SqlClient\\ModelProviderGenerated.cst");
            CodeTemplate DALSqlClientCsprojTemplate = GetCodeTemplate("\\DAL.SqlClient\\DALSqlClientCsproj.cst");
            CodeTemplate AssemblyInfoTemplate = GetCodeTemplate("\\DAL.SqlClient\\AssemblyInfo.cst");
            CodeTemplate ProviderBaseTemplate = GetCodeTemplate("\\DAL.SqlClient\\ProviderBase.cst");


            //Render Filesļдļ
            for (int i = 0; i < Tables.Count; i++)
            {
                //дչ
                if (GenerateAll_DALSqlClient) RenderFileUsingProperties(ProvidersDirectory + GetClassName(Tables[i]) + "Provider.cs", true, ref ModelProviderTemplate, Tables[i]);
                RenderFileUsingProperties(ProvidersDirectory + GetClassName(Tables[i]) + "Provider.Generated.cs", true, ref ModelProviderGeneratedTemplate, Tables[i]);
            }
            RenderFileUsingProperties(DALSqlClientDirectory + "DAL.SqlClient.csproj", true, ref DALSqlClientCsprojTemplate);
            RenderFileUsingProperties(PropertiesDirectory + "AssemblyInfo.cs", true, ref AssemblyInfoTemplate);
            RenderFileUsingProperties(DALSqlClientDirectory + "ProviderBase.cs", true, ref ProviderBaseTemplate);
            
            return true;
        }
        #endregion

        #endregion

        #region IDALӿڲ
        #region Property
        private bool _generatAllIDALCode = false;
        [Category("IDAL")]
        [Description("ȫչ")]
        public bool GenerateAll_IDAL
        {
            get
            {
                return _generatAllIDALCode;
            }
            set
            {
                _generatAllIDALCode = value;
            }
        }

        #endregion

        #region Method
        

        public bool GenerateIDALCode()
        {
            //ļĴļ
            string IDALDirectory = OutputDirectory + "\\" + ProjectName + "\\IDAL\\";
            if (!Directory.Exists(IDALDirectory)) Directory.CreateDirectory(IDALDirectory);

            string IProviderDirectory = OutputDirectory + "\\" + ProjectName + "\\IDAL\\IProviders\\";
            if (!Directory.Exists(IProviderDirectory)) Directory.CreateDirectory(IProviderDirectory);

            string PropertiesDirectory = OutputDirectory + "\\" + ProjectName + "\\IDAL\\Properties\\";
            if (!Directory.Exists(PropertiesDirectory)) Directory.CreateDirectory(PropertiesDirectory);

            //ģ
            CodeTemplate IModelProviderTemplate = GetCodeTemplate("\\IDAL\\IModelProvider.cst");
            CodeTemplate IModelProviderGeneratedTemplate = GetCodeTemplate("\\IDAL\\IModelProviderGenerated.cst");
            CodeTemplate IDALCsprojTemplate = GetCodeTemplate("\\IDAL\\IDALCsproj.cst");
            CodeTemplate IDALAssemblyInfoTemplate = GetCodeTemplate("\\IDAL\\AssemblyInfo.cst");
            CodeTemplate IDALIProviderTemplate = GetCodeTemplate("\\IDAL\\IProvider.cst");
            //Render Filesļдļ
            for (int i = 0; i < Tables.Count; i++)
            {
                //дչ
                if (GenerateAll_IDAL) RenderFileUsingProperties(IProviderDirectory + "I" + GetClassName(Tables[i]) + "Provider.cs", true, ref IModelProviderTemplate, Tables[i]);
                RenderFileUsingProperties(IProviderDirectory + "I" + GetClassName(Tables[i]) + "Provider.Generated.cs", true, ref IModelProviderGeneratedTemplate, Tables[i]);
            }
            RenderFileUsingProperties(IDALDirectory + "IDAL.csproj", true, ref IDALCsprojTemplate);
            RenderFileUsingProperties(PropertiesDirectory + "AssemblyInfo.cs", true, ref IDALAssemblyInfoTemplate);
            RenderFileUsingProperties(IDALDirectory + "IProvider.cs", true, ref IDALIProviderTemplate);
            return true;
        }
        #endregion

        #endregion	

        #region BuildBllCode

        #region Property
        private bool _bLL_GenerateAll = false;
        [Category("BLL")]
        [Description("ȫչ")]
        public bool GenerateAll_BLL
        {
            get
            {
                return _bLL_GenerateAll;
            }
            set
            {
                _bLL_GenerateAll = value;
            }
        }

        #endregion

        #region Method

        
        public bool GenerateBLLCode()
        {
            //ļĴļ趨ļĴļ
            string BLLDirectory = OutputDirectory + "\\" + ProjectName + "\\BLL\\";
            if (!Directory.Exists(BLLDirectory)) Directory.CreateDirectory(BLLDirectory);

            string PropertiesDirectory = OutputDirectory + "\\" + ProjectName + "\\BLL\\Properties\\";
            if (!Directory.Exists(PropertiesDirectory)) Directory.CreateDirectory(PropertiesDirectory);

            string LogicsDirectory = OutputDirectory + "\\" + ProjectName + "\\BLL\\Logics\\";
            if (!Directory.Exists(LogicsDirectory)) Directory.CreateDirectory(LogicsDirectory);


            //ģ                
            CodeTemplate ModelLogicTemplate = GetCodeTemplate("\\BLL\\ModelLogic.cst");
            CodeTemplate ModelLogicGeneratedTemplate = GetCodeTemplate("\\BLL\\ModelLogic.Generated.cst");
            CodeTemplate BLLCsprojTemplate = GetCodeTemplate("\\BLL\\BLLCsproj.cst");
            CodeTemplate AssemblyInfoTemplate = GetCodeTemplate("\\BLL\\AssemblyInfo.cst");


            //Render Filesļдļ
            for (int i = 0; i < Tables.Count; i++)
            {
                //дչ
                if (GenerateAll_BLL) RenderFileUsingProperties(LogicsDirectory + GetClassName(Tables[i]) + "Logic.cs", true, ref ModelLogicTemplate, Tables[i]);
                RenderFileUsingProperties(LogicsDirectory + GetClassName(Tables[i]) + "Logic.Generated.cs", true, ref ModelLogicGeneratedTemplate, Tables[i]);
            }
            RenderFileUsingProperties(BLLDirectory + "BLL.csproj", true, ref BLLCsprojTemplate);
            RenderFileUsingProperties(PropertiesDirectory + "AssemblyInfo.cs", true, ref AssemblyInfoTemplate);

            return true;
        }
        #endregion

        #endregion

        #region ʵģͲ
        #region Property
        private bool _generatAllCode = false;
        [Category("Model")]
        [Description("ȫչ")]
        public bool GenerateAll_Model
        {
            get
            {
                return _generatAllCode;
            }
            set
            {
                _generatAllCode = value;
            }
        }

        #endregion

        #region Method        

        public bool GenerateModelCode()
        {
            //ļĴļ
            string ModelCsprojDirectory = OutputDirectory + "\\" + ProjectName + "\\Model\\";
            if (!Directory.Exists(ModelCsprojDirectory)) Directory.CreateDirectory(ModelCsprojDirectory);

            string ModelDirectory = OutputDirectory + "\\" + ProjectName + "\\Model\\Entities\\";
            if (!Directory.Exists(ModelDirectory)) Directory.CreateDirectory(ModelDirectory);

            string PropertiesDirectory = OutputDirectory + "\\" + ProjectName + "\\Model\\Properties\\";
            if (!Directory.Exists(PropertiesDirectory)) Directory.CreateDirectory(PropertiesDirectory);

            string EntitiesDirectory = OutputDirectory + "\\" + ProjectName + "\\Model\\Entities\\";
            if (!Directory.Exists(EntitiesDirectory)) Directory.CreateDirectory(EntitiesDirectory);

            string PropertyEnumDirectory = OutputDirectory + "\\" + ProjectName + "\\Model\\PropertyEnum\\";
            if (!Directory.Exists(PropertyEnumDirectory)) Directory.CreateDirectory(PropertyEnumDirectory);

            //ģ
            CodeTemplate ModelObjectTemplate = GetCodeTemplate("\\Model\\Entity.cst");
            CodeTemplate EntityGeneratedTemplate = GetCodeTemplate("\\Model\\EntityGenerated.cst");
            CodeTemplate ModelBaseTemplate = GetCodeTemplate("\\Model\\ModelBase.cst");
            CodeTemplate ModelBaseEnumTemplate = GetCodeTemplate("\\Model\\ModelBaseEnum.cst");
            CodeTemplate ModelCsprojTemplate = GetCodeTemplate("\\Model\\ModelCsproj.cst");
            CodeTemplate ModelAssemblyInfoTemplate = GetCodeTemplate("\\Model\\AssemblyInfo.cst");

            //Render Filesļдļ
            for (int i = 0; i < Tables.Count; i++)
            {
                //дչ
                if (GenerateAll_Model) RenderFileUsingProperties(ModelDirectory + GetClassName(Tables[i]) + ".cs", true, ref ModelObjectTemplate, Tables[i]);
                RenderFileUsingProperties(ModelDirectory + GetClassName(Tables[i]) + ".Generated.cs", true, ref EntityGeneratedTemplate, Tables[i]);
            }
            RenderFileUsingProperties(ModelCsprojDirectory + "Model.csproj", true, ref ModelCsprojTemplate);
            RenderFileUsingProperties(PropertiesDirectory + "AssemblyInfo.cs", true, ref ModelAssemblyInfoTemplate);
            RenderFileUsingProperties(ModelDirectory + "ModelBase.cs", true, ref ModelBaseTemplate);
            RenderFileUsingProperties(PropertyEnumDirectory + "ModelBaseEnum.cs", true, ref ModelBaseEnumTemplate);
            return true;
        }
        #endregion

        #endregion	

        #region DAL
        #region Property

        #endregion

        #region Method        

        public bool GenerateDALCode()
        {
            //ļĴļ趨ļĴļ
            string DALDirectory = OutputDirectory + "\\" + ProjectName + "\\DAL\\";
            if (!Directory.Exists(DALDirectory)) Directory.CreateDirectory(DALDirectory);

            string PropertiesDirectory = OutputDirectory + "\\" + ProjectName + "\\DAL\\Properties\\";
            if (!Directory.Exists(PropertiesDirectory)) Directory.CreateDirectory(PropertiesDirectory);

            //ģ                
            CodeTemplate DALFactoryTemplate = GetCodeTemplate("\\DAL\\DALFactory.cst");
            CodeTemplate DALCsprojTemplate = GetCodeTemplate("\\DAL\\DALCsproj.cst");
            CodeTemplate AssemblyInfoTemplate = GetCodeTemplate("\\DAL\\AssemblyInfo.cst");

            //Render Filesļдļ
            RenderFileUsingProperties(DALDirectory + "DALFactory.cs", true, ref DALFactoryTemplate);
            RenderFileUsingProperties(DALDirectory + "DAL.csproj", true, ref DALCsprojTemplate);
            RenderFileUsingProperties(PropertiesDirectory + "AssemblyInfo.cs", true, ref AssemblyInfoTemplate);
            return true;
        }
        #endregion

        #endregion

        #region ɹʵ༭
        #region Property
        //private bool _generatAllCode = false;
        //[Category("Model")]
        //[Description("ȫչ")]
        //public bool GenerateAll_Model
        //{
        //    get
        //    {
        //        return _generatAllCode;
        //    }
        //    set
        //    {
        //        _generatAllCode = value;
        //    }
        //}

        #endregion

        #region Method

        public bool GenerateCommonEditerCode()
        {
            //ļĴļ
            //string ModelCsprojDirectory = OutputDirectory + "\\" + ProjectName + "\\Model\\";
            //if (!Directory.Exists(ModelCsprojDirectory)) Directory.CreateDirectory(ModelCsprojDirectory);

            string CommonEditerDirectory = OutputDirectory + "\\" + ProjectName + "\\CommonEditer\\";
            if (!Directory.Exists(CommonEditerDirectory)) Directory.CreateDirectory(CommonEditerDirectory);

            //string PropertiesDirectory = OutputDirectory + "\\" + ProjectName + "\\Model\\Properties\\";
            //if (!Directory.Exists(PropertiesDirectory)) Directory.CreateDirectory(PropertiesDirectory);

            //ģ
            CodeTemplate ModelEditerTemplate = GetCodeTemplate("\\CommonEditer\\ModelEditer.cst");
            //CodeTemplate EntityGeneratedTemplate = GetCodeTemplate("\\Model\\EntityGenerated.cst");
            CodeTemplate CommonEditerBaseTemplate = GetCodeTemplate("\\CommonEditer\\CommonEditerBase.cst");
            CodeTemplate ModelEditerFactoryTemplate = GetCodeTemplate("\\CommonEditer\\ModelEditerFactory.cst");
            //CodeTemplate ModelCsprojTemplate = GetCodeTemplate("\\Model\\ModelCsproj.cst");
            //CodeTemplate ModelAssemblyInfoTemplate = GetCodeTemplate("\\Model\\AssemblyInfo.cst");

            //Render Filesļдļ
            for (int i = 0; i < Tables.Count; i++)
            {
                //дչ
                //if (GenerateAll_ModelEditer) 
                RenderFileUsingProperties(CommonEditerDirectory + GetClassName(Tables[i]) + "Editer.cs", true, ref ModelEditerTemplate, Tables[i]);
                //RenderFileUsingProperties(CommonEditerDirectory + GetClassName(Tables[i]) + ".cs", true, ref ModelEditerTemplate, Tables[i]);
            }
            //RenderFileUsingProperties(ModelCsprojDirectory + "Model.csproj", true, ref ModelCsprojTemplate);
            //RenderFileUsingProperties(PropertiesDirectory + "AssemblyInfo.cs", true, ref ModelAssemblyInfoTemplate);
            RenderFileUsingProperties(CommonEditerDirectory + "CommonEditerBase.cs", true, ref CommonEditerBaseTemplate);
            RenderFileUsingProperties(CommonEditerDirectory + "ModelEditerFactory.cs", true, ref ModelEditerFactoryTemplate);
            return true;
        }
        #endregion

        #endregion	

        public string ShowPath()
        {
            return this.CodeTemplateInfo.DirectoryName;
        }
    }
}
